/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

public class App extends Application {

    private static Scene scene;
    private static Stage stage;
    private static List<BuildingImageTask> runningTasks = new ArrayList<>();

    public static List<BuildingImageTask> getRunningTasks() {
        return runningTasks;
    }

    public static Scene getScene() {
        return scene;
    }

    public static void setScene(Scene scene) {
        App.scene = scene;
    }

    public static Stage getStage() {
        return stage;
    }

    public static void setStage(Stage stage) {
        App.stage = stage;
    }

    @Override
    public void start(Stage stage) throws IOException {

        HibernateConnectionUtility.getSessionFactory();
        App.setStage(stage);
        App.getStage().setTitle("DB_orchestrator_filler");
        //App.stage.initStyle(StageStyle.UTILITY);
        App.getStage().getIcons().add(new Image("icon.png"));
        setScene(new Scene(loadFXML("welcome"), 1000,650));
        //scene.setFill(Color.TRANSPARENT);
        App.getStage().setScene(getScene());
        App.getStage().centerOnScreen();
        App.getStage().setMinWidth(1000);
        App.getStage().setMinHeight(600);
        App.getStage().show();
    }

    public static void setRoot(String fxml) throws IOException {
        getScene().setRoot(loadFXML(fxml));
    }

    public static Parent loadFXML(String fxml) throws IOException {
        ResourceBundle resources = ResourceBundle.getBundle("internalizationBundles/languageBundle", InternalizationUtility.getLocale());
        FXMLLoader fxmlLoader = new FXMLLoader(App.class.getClassLoader().getResource(  "view/" + fxml + ".fxml"), resources);
        return fxmlLoader.load();
    }

    public static void main(String[] args) {
        launch();
    }
}