/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI;

import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;

import java.util.Locale;

public class InternalizationUtility {

    private static ObjectProperty<Locale> locale;

    public static Locale getLocale() {
        if (locale == null){
            if(Locale.getDefault() == Locale.ENGLISH){
                locale = new SimpleObjectProperty<>(Locale.ENGLISH);
            } else {
                locale = new SimpleObjectProperty<>(new Locale("en"));
            }
        }
        return locale.get();
    }

    public static ObjectProperty<Locale> localeProperty() {
        return locale;
    }

    public static void setLocale(Locale locale) {
        InternalizationUtility.locale.set(locale);
    }


}
