/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.PopUpWindows;

import com.jfoenix.controls.JFXRadioButton;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.ModuleParameter;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Node;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.NodeParameter;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service.ModuleParameterService;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;

public class AddParameterWindowController {

    private Node node;

    private ModuleParameterService moduleParameterService = new ModuleParameterService();

    @FXML
    private MenuButton menuButton;

    @FXML
    private TextField textField;

    @FXML
    private JFXRadioButton isConstant;
    @FXML
    private JFXRadioButton isNotConstant;

    private NodeParameter nodeParameter;

    private boolean selected = false;

    private Stage windowStage;

    public AddParameterWindowController(Stage windowStage) {
        this.windowStage = windowStage;
    }

    public void initialize(){
        ToggleGroup group = new ToggleGroup();
        isConstant.setToggleGroup(group);
        isNotConstant.setToggleGroup(group);
        isConstant.setSelected(true);
    }

    public boolean getSelected() {
        return selected;
    }

    public NodeParameter getNodeParameter() {

        return nodeParameter;
    }

    public void submit(){
        selected = true;
        NodeParameter nodeParameter = new NodeParameter();
        nodeParameter.setNode(node);
        nodeParameter.setName(menuButton.getText());
        nodeParameter.setDefaultValue(textField.getText());
        this.nodeParameter = nodeParameter;
        windowStage.close();
    }

    public void cancel(){
        selected = false;
        NodeParameter nodeParameter = new NodeParameter();
        nodeParameter.setNode(node);
        nodeParameter.setName(textField.getText());
        nodeParameter.setDefaultValue(textField.getText());
        this.nodeParameter = nodeParameter;
        windowStage.close();
    }

    public void loadData(Node node){
        this.node = node;
        for (ModuleParameter moduleParameter : moduleParameterService.getModuleParametersByModuleName(node.getModuleName())){
            MenuItem menuItem = new MenuItem(moduleParameter.getName());
            menuButton.getItems().add(menuItem);
            menuItem.setOnAction((e)-> {
                menuButton.setText(menuItem.getText());
            });
        }
    }

}
