/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.PopUpWindows;

import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.stage.Stage;

public class ChoiceWindowController {

    @FXML
    private Label primaryLabel;
    @FXML
    private Label secondaryLabel;

    private boolean confirmed = false;
    private Stage windowStage;

    public ChoiceWindowController(Stage windowStage) {
        this.windowStage = windowStage;
    }

    public boolean getConfirmed() {
        return confirmed;
    }

    public void delete(){
        confirmed = true;
        windowStage.close();
    }

    public void cancel(){
        confirmed = false;
        windowStage.close();
    }

    public void loadData(String primaryText, String secondaryText){
        primaryLabel.setText(primaryText);
        secondaryLabel.setText(secondaryText);
    }
}
