/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.PopUpWindows;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Module;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service.ModuleService;
import javafx.fxml.FXML;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableRow;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class SelectModuleWindowController {

    private ModuleService moduleService = new ModuleService();

    @FXML
    private TableView<Module> table;

    @FXML
    private TableColumn<Module,String> nameCol;

    @FXML
    private TableColumn<Module,String> typeCol;

    @FXML
    private TableColumn<Module, Boolean> isBlockingCol;

    @FXML
    private TableColumn<Module,Integer> healthPortCol;

    @FXML
    private TableColumn<Module,String> imageCol;

    @FXML
    private TableColumn<Module,String> tagCol;

    private Module selectedModule;
    private Stage stage;

    public void initialize(){
        nameCol.setCellValueFactory(new PropertyValueFactory<>("name"));
        typeCol.setCellValueFactory(new PropertyValueFactory<>("type"));
        isBlockingCol.setCellValueFactory(new PropertyValueFactory<>("isBlocking"));
        healthPortCol.setCellValueFactory(new PropertyValueFactory<>("healthPort"));
        imageCol.setCellValueFactory(new PropertyValueFactory<>("image"));
        tagCol.setCellValueFactory(new PropertyValueFactory<>("tag"));

        table.getItems().addAll(moduleService.getAllModules());

        table.setRowFactory( tv -> {
            TableRow<Module> row = new TableRow<>();
            row.setOnMouseClicked(event -> {
                if (event.getClickCount() == 2 && (! row.isEmpty()) ) {
                    selectedModule = row.getItem();
                    stage.close();
                }
            });
            return row ;
        });
    }

    public void close(){
        stage.close();
    }

    public SelectModuleWindowController(Stage stage) {
        this.stage = stage;
    }

    public Module getSelectedModule() {
        return selectedModule;
    }

}
