/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.PopUpWindows;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.ModuleParameter;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service.ModuleParameterService;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;

public class ShowModuleParameterWindowController {

    private ModuleParameterService moduleParameterService = new ModuleParameterService();

    @FXML
    private TableView<ModuleParameter> table;

    @FXML
    private TableColumn<ModuleParameter, String> nameCol;

    @FXML
    private TableColumn<ModuleParameter, String> defaultValueCol;

    @FXML
    private TableColumn<ModuleParameter, Boolean> isStrictCol;

    @FXML
    private TableColumn<ModuleParameter, String> descriptionCol;

    @FXML
    private Label label;

    private Stage stage;

    public void initialize(){
        nameCol.setCellValueFactory(new PropertyValueFactory<>("name"));
        defaultValueCol.setCellValueFactory(new PropertyValueFactory<>("defaultValue"));
        descriptionCol.setCellValueFactory(new PropertyValueFactory<>("description"));
        isStrictCol.setCellValueFactory(new PropertyValueFactory<>("isStrict"));
    }

    public void close(){
        stage.close();
    }

    public ShowModuleParameterWindowController(Stage stage) {
        this.stage = stage;
    }

    public void loadData(String moduleName){
        label.setText(moduleName + " Module's Parameters");
        table.getItems().addAll(moduleParameterService.getModuleParametersByModuleName(moduleName));
    }
}
