/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.PopUpWindows;

import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class TextFieldWindowControler {

    @FXML
    private TextField textField;

    private boolean selected = false;
    private String text;
    private Stage windowStage;

    public TextFieldWindowControler(Stage windowStage) {
        this.windowStage = windowStage;
    }

    public boolean getSelected() {
        return selected;
    }

    public String getText() {
        return text;
    }

    public void submit(){
        selected = true;
        text = textField.getText();
        windowStage.close();
    }

    public void cancel(){
        selected = false;
        text = textField.getText();
        windowStage.close();
    }
}
