/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.images;

import com.jfoenix.controls.JFXTextField;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.BuildingImageTask;
import javafx.fxml.FXML;
import javafx.stage.FileChooser;
import javafx.stage.Stage;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.App;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.controller.BaseController;

import java.io.File;
import java.io.IOException;

public class AddImageController extends BaseController {

    @FXML
    private JFXTextField repositoryNameField;
    @FXML
    private JFXTextField imageField;
    @FXML
    private JFXTextField tagField;

    private File chosenFile;

    public void chooseFile(){
        Stage stage = new Stage();
        chosenFile =  new FileChooser().showOpenDialog(stage);
        if (chosenFile != null) {
            imageField.setText(chosenFile.getName());
        }
    }

    public void addImage() throws IOException {
        BuildingImageTask task = new BuildingImageTask(chosenFile, repositoryNameField.getText(), tagField.getText());
        Thread thread = new Thread(task);
        thread.setDaemon(true);
        thread.start();
        App.getRunningTasks().add(task);

        task.setOnFailed(e ->
                task.getException().printStackTrace());

        viewBuildingImages();
    }

    public void viewBuildingImages() throws IOException {
        App.setRoot("viewBuildingImages");
    }
}
