/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.HibernateConnectionUtility;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Edge;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import org.hibernate.Session;
import org.hibernate.query.Query;

public class EdgeDAO {

    public ObservableList<Edge> getEdges(){
        Session session = HibernateConnectionUtility.getSessionFactory().openSession();
        session.beginTransaction();
        Query query = session.createQuery("from Edge");
        @SuppressWarnings("unchecked")
        ObservableList<Edge>  list = FXCollections.observableArrayList(query.list());
        session.getTransaction().commit();
        session.close();
        return list;
    }

    public ObservableList<Edge> getEdgesByOperation(String operationName){
        Session session = HibernateConnectionUtility.getSessionFactory().openSession();
        session.beginTransaction();
        Query query = session.createQuery("SELECT e FROM Edge e where e.operation.name = :name");
        query.setParameter("name", operationName);
        @SuppressWarnings("unchecked")
        ObservableList<Edge>  list = FXCollections.observableArrayList(query.list());
        session.getTransaction().commit();
        session.close();
        return list;
    }

    public void addEdge(Edge edge){
        Session session = HibernateConnectionUtility.getSessionFactory().openSession();
        session.beginTransaction();
        session.save(edge);
        session.getTransaction().commit();
        session.close();
    }

    public void updateEdge(Edge edge){
        Session session = HibernateConnectionUtility.getSessionFactory().openSession();
        session.beginTransaction();
        session.update(edge);
        session.getTransaction().commit();
        session.close();
    }

    public void deleteEdge(Edge edge) {
        Session session = HibernateConnectionUtility.getSessionFactory().openSession();
        session.beginTransaction();
        session.delete(edge);
        session.getTransaction().commit();
        session.close();
    }
}
