/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@Entity
@Table(name = "definition_edges")
public class Edge implements Serializable {

    @Id
    @ManyToOne
    @JoinColumn(name = "operation_name", referencedColumnName = "name")
    private Operation operation;

    @Id
    @Column(name = "from_node")
    private int fromNode;

    @Id
    @Column(name = "to_node")
    private  int toNode;

    public Edge() {
    }

    public Edge(Operation operation, int fromNode, int toNode) {
        this.operation = operation;
        this.fromNode = fromNode;
        this.toNode = toNode;
    }

    public Operation getOperation() {
        return operation;
    }

    public void setOperation(Operation operation) {
        this.operation = operation;
    }

    public int getFromNode() {
        return fromNode;
    }

    public void setFromNode(int fromNode) {
        this.fromNode = fromNode;
    }

    public int getToNode() {
        return toNode;
    }

    public void setToNode(int toNode) {
        this.toNode = toNode;
    }

    @Override
    public String toString() {
        return "Edge{" +
                "operation=" + operation +
                ", fromNode=" + fromNode +
                ", toNode=" + toNode +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Edge edge = (Edge) o;
        return fromNode == edge.fromNode &&
                toNode == edge.toNode &&
                Objects.equals(operation, edge.operation);
    }

    @Override
    public int hashCode() {
        return Objects.hash(operation, fromNode, toNode);
    }
}
