/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "definition_module_ports")
public class ModulePort implements Serializable {

    @Id
    @Column(name = "name")
    private String name;

    @Column(name = "number")
    private int number;

    @Column(name = "is_public")
    private boolean isPublic;

    @Id
    @ManyToOne
    @JoinColumn(name = "module", referencedColumnName = "name")
    private Module module;

    public String getName() {
        return name;
    }

    public void setName(String  name) {
        this.name = name;
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public boolean getIsPublic() {
        return isPublic;
    }

    public void setIsPublic(boolean isPublic) {
        this.isPublic = isPublic;
    }

    public Module getModule() {
        return module;
    }

    public void setModule(Module module) {
        this.module = module;
    }
}
