/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Edge;
import javafx.collections.ObservableList;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.EdgeDAO;

public class EdgeService {

    private EdgeDAO edgeDAO = new EdgeDAO();

    public ObservableList<Edge> getEdges(){
        return edgeDAO.getEdges();
    }

    public ObservableList<Edge> getEdgesByOperation(String operationName){
        return edgeDAO.getEdgesByOperation(operationName);
    }

    public void addEdge(Edge edge){
        edgeDAO.addEdge(edge);
    }

    public void updateEdge(Edge edge){
        edgeDAO.updateEdge(edge);
    }

    public void deleteEdge(Edge edge) {
        edgeDAO.deleteEdge(edge);
    }
}
