/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.ModuleParameterDAO;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import org.hibernate.JDBCException;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.ModuleParameter;

public class ModuleParameterService {

    private ModuleParameterDAO moduleParameterDAO = new ModuleParameterDAO();

    public void addModuleParameter(ModuleParameter moduleParameter) {

        try {
            moduleParameterDAO.addModuleParameter(moduleParameter);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public void updateModuleParameter(ModuleParameter moduleParameter){
        moduleParameterDAO.updateModuleParameter(moduleParameter);
    }

    public void deleteModuleParameter(ModuleParameter moduleParameter){
        try {
            moduleParameterDAO.deleteModuleParameter(moduleParameter);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public ObservableList<ModuleParameter> getAllModuleParameters() {
        try {
            return moduleParameterDAO.getAllModuleParameters();
        } catch (JDBCException e) {
            System.out.println(e.getMessage());
        }
        return FXCollections.observableArrayList();
    }

    public ObservableList<ModuleParameter> getModuleParametersByName(String name){
        return moduleParameterDAO.getModuleParametersByName(name);
    }

    public ObservableList<ModuleParameter> getModuleParametersByModuleName(String moduleName){
        return moduleParameterDAO.getModuleParametersByModuleName(moduleName);
    }
}
