/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import org.hibernate.JDBCException;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.ModulePortDAO;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.ModulePort;

public class ModulePortService {

    private ModulePortDAO modulePortDAO = new ModulePortDAO();

    public void addModulePort(ModulePort modulePort) {

        try {
            modulePortDAO.addModulePort(modulePort);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public void updateModulePort(ModulePort modulePort){
        modulePortDAO.updateModulePort(modulePort);
    }

    public void deleteModulePort(ModulePort modulePort){
        try {
            modulePortDAO.deleteModulePort(modulePort);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public ObservableList<ModulePort> getAllModulePorts() {
        try {
            return modulePortDAO.getAllModulePorts();
        } catch (JDBCException e) {
            System.out.println(e.getMessage());
        }
        return FXCollections.observableArrayList();
    }

    public ObservableList<ModulePort> getModulePortsByModuleName(String moduleName){
        return modulePortDAO.getModulePortsByModuleName(moduleName);
    }

    public ObservableList<ModulePort> getModulePortsByName(String name){
        return modulePortDAO.getModulePortsByName(name);
    }

    public ObservableList<ModulePort> getModulePortsByNumber(int number) {
        return modulePortDAO.getModulePortsByNumber(number);
    }
}
