/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.ModuleDAO;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import org.hibernate.JDBCException;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Module;

public class ModuleService {

    private ModuleDAO moduleDAO = new ModuleDAO();

    public void addModule(Module module) {

        try {
            moduleDAO.addModule(module);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public void updateModule(Module module){
        moduleDAO.updateModule(module);
    }

    public void addModulesSuccessor(Module parent, Module successor){
        moduleDAO.addModulesSuccessor(parent, successor);
    }

    public ObservableList<Module> getModulesSuccessors(String moduleName) {

        return moduleDAO.getModulesSuccessors(moduleName);
    }

    public ObservableList<Module> getModuleByName(String moduleName) {
        return moduleDAO.getModuleByName(moduleName);
    }

    public void deleteModule(Module module){
        try {
            moduleDAO.deleteModule(module);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public ObservableList<Module> getAllModules() {
        try {
            return moduleDAO.getAllModule();
        } catch (JDBCException e) {
            System.out.println(e.getMessage());
        }
        return FXCollections.observableArrayList();
    }

}
