/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.NodeDAO;
import javafx.collections.ObservableList;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Node;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Operation;

public class NodeService {

    private NodeDAO nodeDAO = new NodeDAO();

    public ObservableList<Node> getNodes(){
        return nodeDAO.getNodes();
    }

    public ObservableList<Node> getNodesByOperation(String operationName){
        return nodeDAO.getNodesByOperation(operationName);
    }
    public ObservableList<Operation> getNodeByModuleName(String moduleName){
        return nodeDAO.getNodeByModuleName(moduleName);
    }

    public void addNode(Node node){
        nodeDAO.addNode(node);
    }

    public void updateNode(Node node){
        nodeDAO.updateNode(node);
    }


    public void deleteNode(Node node) {
        nodeDAO.deleteNode(node);
    }
}
