/*
 Copyright 2020 Masarykova univerzita

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0


Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.service;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import org.hibernate.JDBCException;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.databaseAccess.OperationDAO;
import cz.fi.muni.ANALYZA.db_orchestrator_filler.GUI.model.Operation;

public class OperationService {
    private OperationDAO operationDAO = new OperationDAO();

    public void addOperation(Operation operation) {
        operationDAO.addOperation(operation);
    }

    public void updateOperation(Operation operation){
        operationDAO.updateOperation(operation);
    }

    public void deleteOperation(Operation operation){
        try {
            operationDAO.deleteOperation(operation);
        }catch (JDBCException e){
            System.out.println(e.getMessage());
        }
    }

    public ObservableList<Operation> getOperationByName(String operationName) {
        try {
            return operationDAO.getOperationByName(operationName);
        } catch (JDBCException e) {
            System.out.println(e.getMessage());
        }
        return FXCollections.observableArrayList();
    }

    public ObservableList<Operation> getOperations(){
        return operationDAO.getOperations();
    }
}
